
#ifndef __IO_H
#define __IO_H

#include <type.h>

#define SLOW_DOWN_IO __asm__ __volatile__("jmp 1f\n1:\tjmp 1f\n1:")

#define DISABLE_INTERRUPT __asm__ __volatile__("cli")
#define ENABLE_INTERRUPT __asm__ __volatile__("sti")

void outb(uint16_t port, uint8_t byte);
void outw(uint16_t port, uint16_t word);
void outl(uint16_t port, uint32_t word);
uint32_t inl(uint16_t port);
uint16_t inw(uint16_t port);
uint8_t inb(uint16_t port);

void outb_pulse(uint16_t port, uint8_t byte);
void outw_pulse(uint16_t port, uint16_t word);
void outl_pulse(uint16_t port, uint32_t word);
uint32_t inl_pulse(uint16_t port);
uint16_t inw_pulse(uint16_t port);
uint8_t inb_pulse(uint16_t port);


// old definitions
//extern inline unsigned char inportb(unsigned short _port);
//extern inline void outportb(unsigned short _port, unsigned char _data);


#endif
